// 			Fragile Base Class problem and solutions
//
// An end user code employing Vendor's B transaction file stream, and 
// the original version of Vendor's A "C++ stream library"

#include "transstream_v1.h"

class MyTransaction: public transaction_fofstream
{
public:
  MyTransaction(const char * file_name) : transaction_fofstream(file_name) {}
};

main(void)
{
  MyTransaction transaction_stream("logfile");
  transaction_stream << "logging";
  transaction_stream << "  .... and logging" << "\n";
  transaction_stream.commit();
  transaction_stream << "transaction 2 logging";
  transaction_stream.backoff();
  transaction_stream << "transaction 3 logging";
  transaction_stream.commit();
  return 0;
}
